<template>
  <el-menu
    class="top-submenu"
    :default-active="activeMenu"
    mode="horizontal"
  >
    <template v-if="userInfo.position == schoolId || userInfo.position == collegeId">
      <el-menu-item :style="{'--theme': theme}" @click="goDataHome()">
        数据可视化
      </el-menu-item>
    </template>
    <template v-for="(item, index) in topMenus">
      <el-menu-item :style="{'--theme': theme}" @click="handleSelect(item)" :index="item.path" :key="index" v-if="index < visibleNumber">
        <!--<svg-icon :icon-class="item.meta.icon" />-->
        {{ item.meta.title }}
      </el-menu-item>
    </template>

    <!-- 顶部菜单超出数量折叠 -->
    <el-submenu :style="{'--theme': theme}" index="more" v-if="topMenus.length > visibleNumber">
      <template slot="title">更多</template>
      <template v-for="(item, index) in topMenus">
        <el-menu-item
          @click="handleSelect(item)"
          class="all-menu"
          :index="item.path"
          :key="index"
          v-if="index >= visibleNumber">
          <!--<svg-icon :icon-class="item.meta.icon" />-->
          {{ item.meta.title }}
        </el-menu-item>
      </template>
    </el-submenu>
  </el-menu>
</template>

<script>
import { constantRoutes } from "@/router";
import store from '@/store'
import { xmlRequestLink } from "@/utils/menuLink";
import { getToken,setSchoolToken,setCollegeToken } from '@/utils/auth'

export default {
  data() {
    return {
      // 顶部栏初始数
      visibleNumber: 6,
      // 是否为首次加载
      isFrist: false,
      // 当前激活菜单的 index
      currentIndex: undefined,
      routerType:true,
      userInfo:JSON.parse(localStorage.getItem('user')),
      schoolId:process.env.VUE_APP_SCHOOL_ID,
      collegeId:process.env.VUE_APP_COLLEGE_ID,
    };
  },
  computed: {
    theme() {
      return this.$store.state.settings.theme;
    },
    // 顶部显示菜单
    topMenus() {
      let topMenus = [];
      this.routers.map((menu) => {
        if (menu.hidden !== true) {
          // 兼容顶部栏一级菜单内部跳转
          if (menu.path === "/") {
              topMenus.push(menu.children[0]);
          } else {
              topMenus.push(menu);
          }
        }
      });
      return topMenus;
    },
    // 所有的路由信息
    routers() {
      return this.$store.state.permission.topbarRouters;
    },
    // 设置子路由
    childrenMenus() {
      var childrenMenus = [];
      this.routers.map((router) => {
        for (var item in router.children) {
          if (router.children[item].parentPath === undefined) {
            if(router.path === "/") {
              router.children[item].path = "/redirect/" + router.children[item].path;
            } else {
              if(!this.ishttp(router.children[item].path)) {
                router.children[item].path = router.path + "/" + router.children[item].path;
              }
            }
            router.children[item].parentPath = router.path;
          }
          childrenMenus.push(router.children[item]);
        }
      });
      return constantRoutes.concat(childrenMenus);
    },
    // 默认激活的菜单
    activeMenu() {
      // if(this.$route.path == '/message' || this.$route.path == '/integratedManagement/individualCenter'){
      //   return
      // }
      const path = this.$route.path;
      let activePath = this.defaultRouter();
      if (path.lastIndexOf("/") > 0) {
        const tmpPath = path.substring(1, path.length);
        activePath = "/" + tmpPath.substring(0, tmpPath.indexOf("/"));
      } else if ("/index" == path || "" == path) {
        if (!this.isFrist) {
          this.isFrist = true;
        } else {
          activePath = "index";
        }
      }
      if(this.routerType){
        this.routerType = false;
        var routes = this.activeRoutes(activePath);
        if (routes.length === 0) {
          activePath = this.currentIndex || this.defaultRouter()
          this.activeRoutes(activePath);
        }
      }
      return activePath;
    },
  },
  beforeMount() {
    window.addEventListener('resize', this.setVisibleNumber)
  },
  beforeDestroy() {
    window.removeEventListener('resize', this.setVisibleNumber)
  },
  mounted() {
    this.setVisibleNumber();
  },
  methods: {
    goDataHome(){
      let userInfo = JSON.parse(localStorage.getItem('user'));
      let schoolId = process.env.VUE_APP_SCHOOL_ID;
      let collegeId = process.env.VUE_APP_COLLEGE_ID;
      localStorage.setItem('entranceJumpType','PC');
      if(userInfo.position == schoolId){
        //跳转校级大屏
        setSchoolToken(getToken());
        if(this.urlData()){
          window.open('http://172.16.0.65/schoolData/#/')
          // window.open('http://192.168.1.8/schoolBigWeb/#/')
        }else{
          window.open('https://labcontrol.nwafu.edu.cn/schoolData/#/')
          // window.open('http://192.168.1.8/schoolBigWeb/#/')
        }
      }else if(userInfo.position == collegeId){
        //跳转院级大屏
        setCollegeToken(getToken());
        if(this.urlData()){
          window.open('http://172.16.0.65/collegeData/#/')
          // window.open('http://192.168.1.8/bigWeb/#/')
        }else{
          window.open('https://labcontrol.nwafu.edu.cn/collegeData/#/')
          // window.open('http://192.168.1.8/bigWeb/#/')
        }
      }else{
        this.msgError('没有相关权限,请联系管理员.')
      }
    },
    urlData() {
      /*判断是否是内网IP*/
      // 获取当前页面url
      var curPageUrl = window.location.href;
      var reg1 = /(http|ftp|https|www):\/\//g;//去掉前缀
      curPageUrl =curPageUrl.replace(reg1,'');
      var reg2 = /\:+/g;//替换冒号为一点
      curPageUrl =curPageUrl.replace(reg2,'.');
      curPageUrl = curPageUrl.split('.');//通过一点来划分数组
      var ipAddress = curPageUrl[0]+'.'+curPageUrl[1]+'.'+curPageUrl[2]+'.'+curPageUrl[3];
      var isInnerIp = false;//默认给定IP不是内网IP
      var ipNum = getIpNum(ipAddress);
      /**
       * 私有IP：A类  10.0.0.0    -10.255.255.255
       *       B类  172.16.0.0  -172.31.255.255
       *       C类  192.168.0.0 -192.168.255.255
       *       D类   127.0.0.0   -127.255.255.255(环回地址)
       **/
      var aBegin = getIpNum("10.0.0.0");
      var aEnd = getIpNum("10.255.255.255");
      var bBegin = getIpNum("172.16.0.0");
      var bEnd = getIpNum("172.31.255.255");
      var cBegin = getIpNum("192.168.0.0");
      var cEnd = getIpNum("192.168.255.255");
      var dBegin = getIpNum("127.0.0.0");
      var dEnd = getIpNum("127.255.255.255");
      isInnerIp = isInner(ipNum,aBegin,aEnd) || isInner(ipNum,bBegin,bEnd) || isInner(ipNum,cBegin,cEnd) || isInner(ipNum,dBegin,dEnd);
      return !!isInnerIp;
      /*获取IP数*/
      function getIpNum(ipAddress) {
        var ip = ipAddress.split(".");
        var a = parseInt(ip[0]);
        var b = parseInt(ip[1]);
        var c = parseInt(ip[2]);
        var d = parseInt(ip[3]);
        var ipNum = a * 256 * 256 * 256 + b * 256 * 256 + c * 256 + d;
        return ipNum;
      }
      function isInner(userIp,begin,end){
        return (userIp>=begin) && (userIp<=end);
      }
    },
    // 根据宽度计算设置显示栏数
    setVisibleNumber() {
      const width = document.body.getBoundingClientRect().width / 3;
      // this.visibleNumber = parseInt(width / 85);
    },
    // 默认激活的路由
    defaultRouter() {
      let self = this;
      let router;
      Object.keys(this.routers).some((key) => {
        if (!this.routers[key].hidden) {
          router = this.routers[key].path;
          return true;
        }
      });
      let matched = this.$route.matched.filter(item => item.meta && item.meta.title)
      for(let i=0;i<self.topMenus.length;i++){
        if(matched[0]){
          if(matched[0].path == self.topMenus[i].path){
            if(matched[0].meta.title != '数据可视化'){
              store.dispatch('settings/setPageName', matched[0].meta.title)
            }
          }
        }
      }
      return router;
    },
    goPage(obj,parent,item){
      console.log('obj',obj)
      console.log('parent',parent)
      console.log('item',item)
      //obj最上级数据 parent目标父级数据 item目标数据
      if(obj){
        console.log('1')
        if(obj.isFrame){
          xmlRequestLink(obj);
        }else{
          if(obj.children){
            console.log('11',parent.path+item.path)
            this.currentIndex = obj.path;
            this.activeRoutes(obj.path);
            this.$router.push({
              path: parent.path+'/'+item.path
            });
          }else{
            this.msgError('这是一个空目录')
          }
        }
      }else{
        console.log('2')
        if(parent.isFrame){
          xmlRequestLink(parent);
        }else{
          if(parent.children){
            this.currentIndex = parent.path;
            this.activeRoutes(parent.path);
            this.$router.push({
              path: item.path
            });
          }else{
            this.msgError('这是一个空目录')
          }
        }
      }
    },
    // 菜单选择事件
    handleSelect(item) {
      if(item.isFrame){
        xmlRequestLink(item);
      }else{
        if(item.children){
          this.currentIndex = item.path;
          this.activeRoutes(item.path);
          for(let i=0;i<item.children.length;i++){
            if(item.children[i].children){
              for(let o=0;o<item.children[i].children.length;o++){
                if(!item.children[i].children[o].isFrame){
                  //路由跳转
                  this.$router.push({
                    path: item.children[i].path+'/'+item.children[i].children[o].path
                  });
                  return
                }
              }
            }else{
              if(!item.children[i].isFrame){
                //路由跳转
                this.$router.push({
                  path: item.children[i].path
                });
                return
              }
            }
          }
          // this.msgError('该目录没有可跳转的页面')
        }else{
          this.msgError('这是一个空目录')
        }
      }
    },
    // 当前激活的路由
    activeRoutes(key) {
      let self = this;
      var routes = [];
      if (this.childrenMenus && this.childrenMenus.length > 0) {
        this.childrenMenus.map((item) => {
          // if (key == item.parentPath || (key == "index" && "" == item.path)) {
          if (key == item.parentPath || (key == "index" && "" == item.path)) {
            routes.push(item);
          }
        });
      }
      if(routes.length > 0) {
        for(let i=0;i<self.topMenus.length;i++){
          if(key == self.topMenus[i].path){
            localStorage.setItem('leftRoutesName',self.topMenus[i].meta.title);
          }
        }
        localStorage.setItem('leftRoutesData',JSON.stringify(routes));
        if(routes[0].path != ''){
          this.$store.commit("SET_SIDEBAR_ROUTERS", routes);
        }
      }else{
        store.dispatch('settings/setPageName', localStorage.getItem('leftRoutesName'))
        this.$store.commit("SET_SIDEBAR_ROUTERS", JSON.parse(localStorage.getItem('leftRoutesData')));
      }
      return routes;
    },
	ishttp(url) {
      return url.indexOf('http://') !== -1 || url.indexOf('https://') !== -1
    }
  },
};
</script>

<style lang="scss">
.topmenu-container.el-menu--horizontal > .el-menu-item {
  float: left;
  height: 80px !important;
  line-height: 80px !important;
  color: #fff !important;
  padding: 0 5px !important;
  margin: 0 10px !important;
}

.topmenu-container.el-menu--horizontal > .el-menu-item.is-active, .el-menu--horizontal > .el-submenu.is-active .el-submenu__title {
  border-bottom: 2px solid #{'var(--theme)'} !important;
  color: #303133;
}

/* submenu item */
.topmenu-container.el-menu--horizontal > .el-submenu .el-submenu__title {
  float: left;
  height: 50px !important;
  line-height: 50px !important;
  color: #999093 !important;
  padding: 0 5px !important;
  margin: 0 10px !important;
}
.top-submenu{
  .el-submenu__title i{
    color:#fff;
  }
}
</style>
